import { injectable } from 'inversify';
import { inject } from '../../core/inject';
import { ISessionHelper } from '../session/i-session-helper';
import { FileAppWindow } from './file-app-window';

@injectable()
export class MainAppWindow extends FileAppWindow {
  public constructor(@inject('session-helper') sessionHelper: ISessionHelper) {
    super(sessionHelper, 'frontend/index.html', {
      webPreferences: {
        nodeIntegration: true,
      },
    });
  }
}
